## highway 0.17.1~git20220711.f0a396a

=== CMakeLists.txt ===
# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.10)

# Set PIE flags for POSITION_INDEPENDENT_CODE targets, added in 3.14.
if(POLICY CMP0083)
  cmake_policy(SET CMP0083 NEW)
endif()

project(hwy VERSION 0.17.0)  # Keep in sync with highway.h version

# Directly define the ABI version from the cmake project() version values:
set(LIBRARY_VERSION "${hwy_VERSION}")
set(LIBRARY_SOVERSION ${hwy_VERSION_MAJOR})

set(CMAKE_CXX_EXTENSIONS OFF)

# Enabled PIE binaries by default if supported.
include(CheckPIESupported OPTIONAL RESULT_VARIABLE CHECK_PIE_SUPPORTED)
if(CHECK_PIE_SUPPORTED)
  check_pie_supported(LANGUAGES CXX)
  if(CMAKE_CXX_LINK_PIE_SUPPORTED)
    set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)
  endif()
endif()

include(GNUInstallDirs)

if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

set(HWY_CMAKE_ARM7 OFF CACHE BOOL "Set copts for ARMv7 with NEON (requires vfpv4)?")

# Unconditionally adding -Werror risks breaking the build when new warnings
# arise due to compiler/platform changes. Enable this in CI/tests.
set(HWY_WARNINGS_ARE_ERRORS OFF CACHE BOOL "Add -Werror flag?")

set(HWY_ENABLE_CONTRIB ON CACHE BOOL "Include contrib/")
set(HWY_ENABLE_EXAMPLES ON CACHE BOOL "Build examples")
set(HWY_ENABLE_INSTALL ON CACHE BOOL "Install library")

include(CheckCXXSourceCompiles)
check_cxx_source_compiles(
   "int main() {
      #if !defined(__EMSCRIPTEN__)
      static_assert(false, \"__EMSCRIPTEN__ is not defined\");
      #endif
      return 0;
    }"
  HWY_EMSCRIPTEN
)

check_cxx_source_compiles(
   "int main() {
      #if !defined(__riscv)
      static_assert(false, \"__riscv is not defined\");
      #endif
      return 0;
    }"
  HWY_RISCV
)

if (HWY_ENABLE_CONTRIB)
# Glob all the traits so we don't need to modify this file when adding
# additional special cases.
file(GLOB HWY_CONTRIB_SOURCES "hwy/contrib/sort/vqsort_*.cc")
list(APPEND HWY_CONTRIB_SOURCES
    hwy/contrib/dot/dot-inl.h
    hwy/contrib/image/image.cc
    hwy/contrib/image/image.h
    hwy/contrib/math/math-inl.h
    hwy/contrib/sort/shared-inl.h
    hwy/contrib/sort/sorting_networks-inl.h
    hwy/contrib/sort/traits-inl.h
    hwy/contrib/sort/traits128-inl.h
    hwy/contrib/sort/vqsort-inl.h
    hwy/contrib/sort/vqsort.cc
    hwy/contrib/sort/vqsort.h
)
endif()  # HWY_ENABLE_CONTRIB

set(HWY_SOURCES
    hwy/aligned_allocator.cc
    hwy/aligned_allocator.h
    hwy/base.h
    hwy/cache_control.h
    hwy/detect_compiler_arch.h  # private
    hwy/detect_targets.h  # private
    hwy/foreach_target.h
    hwy/highway.h
    hwy/highway_export.h
    hwy/nanobenchmark.cc
    hwy/nanobenchmark.h
    hwy/ops/arm_neon-inl.h
    hwy/ops/arm_sve-inl.h
    hwy/ops/emu128-inl.h
    hwy/ops/generic_ops-inl.h
    hwy/ops/scalar-inl.h
    hwy/ops/set_macros-inl.h
    hwy/ops/shared-inl.h
    hwy/ops/wasm_128-inl.h
    hwy/ops/x86_128-inl.h
    hwy/ops/x86_256-inl.h
    hwy/ops/x86_512-inl.h
    hwy/per_target.cc
    hwy/per_target.h
    hwy/print-inl.h
    hwy/print.cc
    hwy/print.h
    hwy/targets.cc
    hwy/targets.h
)

set(HWY_TEST_SOURCES
    hwy/tests/hwy_gtest.h
    hwy/tests/test_util-inl.h
    hwy/tests/test_util.cc
    hwy/tests/test_util.h
)

if (MSVC)
  set(HWY_FLAGS
    # fix build error C1128 in blockwise*_test & arithmetic_test
    /bigobj
  )
else()
  set(HWY_FLAGS
    # Avoid changing binaries based on the current time and date.
    -Wno-builtin-macro-redefined
    -D__DATE__="redacted"
    -D__TIMESTAMP__="redacted"
    -D__TIME__="redacted"

    # Optimizations
    -fmerge-all-constants

    # Warnings
    -Wall
    -Wextra
    # These are not included in Wall nor Wextra:
    -Wconversion
    -Wsign-conversion
    -Wvla
    -Wnon-virtual-dtor
  )

  if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
    list(APPEND HWY_FLAGS
      -Wfloat-overflow-conversion
      -Wfloat-zero-conversion
      -Wfor-loop-analysis
      -Wgnu-redeclared-enum
      -Winfinite-recursion
      -Wself-assign
      -Wstring-conversion
      -Wtautological-overlap-compare
      -Wthread-safety-analysis
      -Wundefined-func-template

      -fno-cxx-exceptions
      -fno-slp-vectorize
      -fno-vectorize

      # Use color in messages
      -fdiagnostics-show-option -fcolor-diagnostics
    )
    if (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 6.0)
      list(APPEND HWY_FLAGS -Wc++2a-extensions)
    endif()
  endif()

  if (WIN32)
    if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
      list(APPEND HWY_FLAGS
        -Wno-global-constructors
        -Wno-language-extension-token
        -Wno-used-but-marked-unused
        -Wno-shadow-field-in-constructor
        -Wno-unused-member-function
        -Wno-unused-template
        -Wno-c++98-compat-pedantic
        -Wno-used-but-marked-unused
        -Wno-zero-as-null-pointer-constant
      )
    endif()

    list(APPEND HWY_FLAGS
      -Wno-cast-align
      -Wno-double-promotion
      -Wno-float-equal
      -Wno-format-nonliteral
      -Wno-shadow
      -Wno-sign-conversion
    )
  else()
    list(APPEND HWY_FLAGS
      -fmath-errno
      -fno-exceptions
    )
  endif()  # WIN32

  if (HWY_CMAKE_ARM7)
    list(APPEND HWY_FLAGS
      -march=armv7-a
      -mfpu=neon-vfpv4
      -mfloat-abi=hard  # must match the toolchain specified as CXX=
      -mfp16-format=ieee  # required for vcvt_f32_f16
    )
  endif()  # HWY_CMAKE_ARM7

  if(HWY_RISCV)
    list(APPEND HWY_FLAGS -march=rv64gcv1p0)
    if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
      list(APPEND HWY_FLAGS -menable-experimental-extensions)
    endif()
  endif()

  if (HWY_WARNINGS_ARE_ERRORS)
    list(APPEND HWY_FLAGS -Werror)
  endif()

endif()  # !MSVC

# By default prefer STATIC build (legacy behavior)
option(BUILD_SHARED_LIBS "Build shared libraries" OFF)
option(HWY_FORCE_STATIC_LIBS "Ignore BUILD_SHARED_LIBS" OFF)
# only expose shared/static options to advanced users:
mark_as_advanced(BUILD_SHARED_LIBS)
mark_as_advanced(HWY_FORCE_STATIC_LIBS)
# Define visibility settings globally:
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)

# Copy-cat "add_library" logic + add override.
set(HWY_LIBRARY_TYPE "SHARED")
if (NOT BUILD_SHARED_LIBS OR HWY_FORCE_STATIC_LIBS)
  set(HWY_LIBRARY_TYPE "STATIC")
endif()

# This preprocessor define will drive the build, also used in the *.pc files:
if("${HWY_LIBRARY_TYPE}" STREQUAL "SHARED")
  set(DLLEXPORT_TO_DEFINE "HWY_SHARED_DEFINE")
else()
  set(DLLEXPORT_TO_DEFINE "HWY_STATIC_DEFINE")
endif()

add_library(hwy ${HWY_LIBRARY_TYPE} ${HWY_SOURCES})
target_compile_definitions(hwy PUBLIC "${DLLEXPORT_TO_DEFINE}")
target_compile_options(hwy PRIVATE ${HWY_FLAGS})
set_property(TARGET hwy PROPERTY POSITION_INDEPENDENT_CODE ON)
set_target_properties(hwy PROPERTIES VERSION ${LIBRARY_VERSION} SOVERSION ${LIBRARY_SOVERSION})
target_include_directories(hwy PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
target_compile_features(hwy PUBLIC cxx_std_11)
set_target_properties(hwy PROPERTIES
  LINK_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/hwy/hwy.version)
# not supported by MSVC/Clang, safe to skip (we use DLLEXPORT annotations)
if(UNIX AND NOT APPLE)
  set_property(TARGET hwy APPEND_STRING PROPERTY
    LINK_FLAGS " -Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/hwy/hwy.version")
endif()

if (HWY_ENABLE_CONTRIB)
add_library(hwy_contrib ${HWY_LIBRARY_TYPE} ${HWY_CONTRIB_SOURCES})
target_link_libraries(hwy_contrib hwy)
target_compile_options(hwy_contrib PRIVATE ${HWY_FLAGS})
set_property(TARGET hwy_contrib PROPERTY POSITION_INDEPENDENT_CODE ON)
set_target_properties(hwy_contrib PROPERTIES VERSION ${LIBRARY_VERSION} SOVERSION ${LIBRARY_SOVERSION})
target_include_directories(hwy_contrib PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
target_compile_features(hwy_contrib PUBLIC cxx_std_11)
set_target_properties(hwy_contrib PROPERTIES
  LINK_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/hwy/hwy.version)
# not supported by MSVC/Clang, safe to skip (we use DLLEXPORT annotations)
if(UNIX AND NOT APPLE)
  set_property(TARGET hwy_contrib APPEND_STRING PROPERTY
    LINK_FLAGS " -Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/hwy/hwy.version")
endif()
endif()  # HWY_ENABLE_CONTRIB

add_library(hwy_test ${HWY_LIBRARY_TYPE} ${HWY_TEST_SOURCES})
target_link_libraries(hwy_test hwy)
target_compile_options(hwy_test PRIVATE ${HWY_FLAGS})
set_property(TARGET hwy_test PROPERTY POSITION_INDEPENDENT_CODE ON)
set_target_properties(hwy_test PROPERTIES VERSION ${LIBRARY_VERSION} SOVERSION ${LIBRARY_SOVERSION})
target_include_directories(hwy_test PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
target_compile_features(hwy_test PUBLIC cxx_std_11)
set_target_properties(hwy_test PROPERTIES
  LINK_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/hwy/hwy.version)
# not supported by MSVC/Clang, safe to skip (we use DLLEXPORT annotations)
if(UNIX AND NOT APPLE)
  set_property(TARGET hwy_test APPEND_STRING PROPERTY
    LINK_FLAGS " -Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/hwy/hwy.version")
endif()

# -------------------------------------------------------- hwy_list_targets
# Generate a tool to print the compiled-in targets as defined by the current
# flags. This tool will print to stderr at build time, after building hwy.
add_executable(hwy_list_targets hwy/tests/list_targets.cc)
target_compile_options(hwy_list_targets PRIVATE ${HWY_FLAGS})
target_link_libraries(hwy_list_targets hwy)
target_include_directories(hwy_list_targets PRIVATE
  $<TARGET_PROPERTY:hwy,INCLUDE_DIRECTORIES>)
# TARGET_FILE always returns the path to executable
# Naked target also not always could be run (due to the lack of '.\' prefix)
# Thus effective command to run should contain the full path
# and emulator prefix (if any).
if (NOT CMAKE_CROSSCOMPILING OR CMAKE_CROSSCOMPILING_EMULATOR)
add_custom_command(TARGET hwy_list_targets POST_BUILD
    COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:hwy_list_targets> || (exit 0))
endif()

# --------------------------------------------------------
# Allow skipping the following sections for projects that do not need them:
# tests, examples, benchmarks and installation.

# -------------------------------------------------------- install library
if (HWY_ENABLE_INSTALL)

install(TARGETS hwy
  LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
  ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
  RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")
# Install all the headers keeping the relative path to the current directory
# when installing them.
foreach (source ${HWY_SOURCES})
  if ("${source}" MATCHES "\.h$")
    get_filename_component(dirname "${source}" DIRECTORY)
    install(FILES "${source}"
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${dirname}")
  endif()
endforeach()

if (HWY_ENABLE_CONTRIB)
install(TARGETS hwy_contrib
  LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
  ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
  RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")
# Install all the headers keeping the relative path to the current directory
# when installing them.
foreach (source ${HWY_CONTRIB_SOURCES})
  if ("${source}" MATCHES "\.h$")
    get_filename_component(dirname "${source}" DIRECTORY)
    install(FILES "${source}"
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${dirname}")
  endif()
endforeach()
endif()  # HWY_ENABLE_CONTRIB

install(TARGETS hwy_test

## highway 1.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,7 @@
   cmake_policy(SET CMP0083 NEW)
 endif()
 
-project(hwy VERSION 0.17.0)  # Keep in sync with highway.h version
+project(hwy VERSION 1.0.0)  # Keep in sync with highway.h version
 
 # Directly define the ABI version from the cmake project() version values:
 set(LIBRARY_VERSION "${hwy_VERSION}")
@@ -232,6 +232,12 @@
     list(APPEND HWY_FLAGS -Werror)
   endif()
 
+  # Prevent "wasm-ld: error: --shared-memory is disallowed by targets.cc.o
+  # because it was not compiled with 'atomics' or 'bulk-memory' features."
+  if (HWY_EMSCRIPTEN)
+    list(APPEND HWY_FLAGS -matomics)
+  endif()
+
 endif()  # !MSVC
 
 # By default prefer STATIC build (legacy behavior)
@@ -357,11 +363,3 @@
 # when installing them.
 foreach (source ${HWY_CONTRIB_SOURCES})
   if ("${source}" MATCHES "\.h$")
-    get_filename_component(dirname "${source}" DIRECTORY)
-    install(FILES "${source}"
-        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${dirname}")
-  endif()
-endforeach()
-endif()  # HWY_ENABLE_CONTRIB
-
-install(TARGETS hwy_test

=== debian/changelog ===
highway (1.0.0-1) unstable; urgency=medium

  * d/watch: Fix typo in watch file
  * d/copyright: Simplify copyright file
  * New upstream version 1.0.0
  * d/rules: Build SCALAR instead of EMU128
  * d/patches: Remove patches applied upstream
  * d/symbols: Update symbols file for new ABI

 -- Mathieu Malaterre <malat@debian.org>  Mon, 01 Aug 2022 10:50:07 +0200

highway (0.17.0-11) unstable; urgency=medium

  * d/patches: Fix blockwise_test on big-endian arches

 -- Mathieu Malaterre <malat@debian.org>  Wed, 20 Jul 2022 17:21:46 +0200

highway (0.17.0-10) unstable; urgency=medium

  * d/rules: Prefer DEB_BUILD_ARCH_CPU over DEB_BUILD_ARCH
  * d/rules: Do not report warnings as errors anymore. Closes: #1012944
  * d/rules: Simplify handling of hurd+qemu
  * d/patches: Revert baseline EMU128 back to SCALAR. Closes: #1015256

 -- Mathieu Malaterre <malat@debian.org>  Mon, 18 Jul 2022 15:42:24 +0200

highway (0.17.0-9) unstable; urgency=medium

  * d/rules: Really fix armhf build

 -- Mathieu Malaterre <malat@debian.org>  Tue, 05 Jul 2022 14:18:09 +0200

highway (0.17.0-8) unstable; urgency=medium

  * d/rules: Make sure to cleanup generated files
  * d/rules: Do not run test on -indep target
  * d/rules: Make sure to return true on hurd-i386
  * d/rules: Work around an issue with gcc-11/O2 combination
  * d/patches: Remove arm WIP for now

 -- Mathieu Malaterre <malat@debian.org>  Tue, 05 Jul 2022 11:18:15 +0200

highway (0.17.0-7) experimental; urgency=medium

  * d/rules: Make sure to skip most rules for indep
  * d/rules: Shrink the main PDF file using gs
  * d/patches: Fix dynamic dispatch on linux/armhf. Closes: #1014330

 -- Mathieu Malaterre <malat@debian.org>  Mon, 04 Jul 2022 15:31:59 +0200

highway (0.17.0-6) experimental; urgency=low

  * d/rules: Make sure to install binaries
  * d/rules: Attempt to get neon on armhf working

 -- Mathieu Malaterre <malat@debian.org>  Mon, 04 Jul 2022 12:13:12 +0200

highway (0.17.0-5) experimental; urgency=low

  * d/rules: Remove no-psabi warning on both armel and armhf
  * d/rules: Re-add extension on i386
  * d/rules: Run the compiled example

 -- Mathieu Malaterre <malat@debian.org>  Mon, 04 Jul 2022 11:04:54 +0200

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DPKG_GENSYMBOLS_CHECK_LEVEL = 4

%:
	dh $@ --buildsystem=cmake+ninja

# Prefer SCALAR over EMU128 for now, see #1015256
DEB_CXXFLAGS_MAINT_APPEND += -DHWY_BROKEN_EMU128=1

ifneq (,$(filter $(DEB_BUILD_ARCH), armhf armel))
  # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=77728
  DEB_CXXFLAGS_MAINT_APPEND += -Wno-psabi
endif

ifeq ($(DEB_BUILD_ARCH),$(filter $(DEB_BUILD_ARCH),armhf))
  # https://github.com/google/highway/issues/495
  CMAKE_EXTRA_FLAGS += -DHWY_CMAKE_ARM7:BOOL=OFF
endif

export DEB_CXXFLAGS_MAINT_APPEND

# test suite rely on CMAKE_SKIP_RPATH=OFF
CMAKE_EXTRA_FLAGS += \
 -DCMAKE_SKIP_RPATH:BOOL=OFF \
 -DBUILD_SHARED_LIBS:BOOL=ON \
 -DHWY_WARNINGS_ARE_ERRORS:BOOL=OFF \
 -DHWY_SYSTEM_GTEST:BOOL=ON

override_dh_auto_configure-arch:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

# run default example to check compilation ok:
override_dh_install-arch:
ifeq (,$(filter $(DEB_BUILD_ARCH),hurd-i386))
	obj-*/examples/hwy_benchmark
else
	echo "CPU 'QEMU Virtual CPU version 2.5+' does not support RDTSCP, skipping benchmark."
endif
	dh_install

override_dh_clean-indep:
	dh_clean debian_docs/

override_dh_auto_configure-indep:
override_dh_auto_build-indep:
	# most docs are ok as-is
	cp -a g3doc debian_docs
	# let's shrink a bit this one:
	gs  -q -dNOPAUSE -dBATCH -dSAFER \
		-sDEVICE=pdfwrite \
		-dCompatibilityLevel=1.4 \
		-dPDFSETTINGS=/screen \
		-dEmbedAllFonts=true \
		-dSubsetFonts=true \
		-dColorImageDownsampleType=/Bicubic \
		-dColorImageResolution=72 \
		-dGrayImageDownsampleType=/Bicubic \
		-dGrayImageResolution=72 \
		-dMonoImageDownsampleType=/Bicubic \
		-dMonoImageResolution=72 \
		-sOutputFile=debian_docs/highway_intro.pdf ./g3doc/highway_intro.pdf

override_dh_auto_test-indep:
override_dh_auto_install-indep:
override_dh_compress-indep:
	# do not compress .pdf/.md files for documentation
	dh_compress -X.md -X.pdf

## highway 1.0.1

=== debian/changelog ===
highway (1.0.1-2) unstable; urgency=medium

  * d/patches: cherry-pick patch upstream to fix compilation on riscv64
  * d/rules: Remove hack on riscv64 not needed anymore
  * d/patches: Properly detect HWY_BROKEN_EMU128 / GCC 12.x
  * d/rules: Comment out HWY_BROKEN_EMU128 hack now detection is working

 -- Mathieu Malaterre <malat@debian.org>  Wed, 31 Aug 2022 09:00:14 +0200

highway (1.0.1-1) unstable; urgency=medium

  * New upstream version 1.0.1
  * d/patches: Refresh patches for new upstream release

 -- Mathieu Malaterre <malat@debian.org>  Thu, 25 Aug 2022 09:37:14 +0200

highway (1.0.0-5) unstable; urgency=medium

  * d/patches: Do not always inline
  * d/patches: fix floating-point generator for sort tests.

 -- Mathieu Malaterre <malat@debian.org>  Thu, 04 Aug 2022 08:39:49 +0200

highway (1.0.0-4) unstable; urgency=medium

  * d/rules: Make sure to skip RVV logic on riscv64
  * d/rules: Start building with neon extension on armhf
  * d/patches: fix spurious use after free warning
  * d/patches: fix preprocessor int overflow warning
  * d/patches: link with atomic for GCC

 -- Mathieu Malaterre <malat@debian.org>  Tue, 02 Aug 2022 14:02:56 +0200

highway (1.0.0-3) unstable; urgency=medium

  * d/patches: Add atomic patch to fix compilation
  * d/patches: Add riscv64 compilation fix for GCC

 -- Mathieu Malaterre <malat@debian.org>  Tue, 02 Aug 2022 10:38:12 +0200

highway (1.0.0-2) unstable; urgency=medium

  * d/symbols: Fix symbols file on 32bits arch

 -- Mathieu Malaterre <malat@debian.org>  Tue, 02 Aug 2022 07:44:42 +0200

=== debian/control ===
Source: highway
Section: libs
Priority: optional
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Mathieu Malaterre <malat@debian.org>
Build-Depends: cmake (>= 3.13), debhelper (>= 11), libgtest-dev, ninja-build
Build-Depends-Indep: ghostscript
Standards-Version: 4.6.1
Homepage: https://github.com/google/highway
Vcs-Git: https://salsa.debian.org/debian-phototools-team/highway.git
Vcs-Browser: https://salsa.debian.org/debian-phototools-team/highway
Rules-Requires-Root: no

Package: libhwy1
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: Efficient and performance-portable SIMD wrapper (runtime files)
 This library provides type-safe and source-code portable wrappers over
 existing platform-specific intrinsics. Its design aims for simplicity,
 reliable efficiency across platforms, and immediate usability with current
 compilers.
 .
 This package installs the runtime files.

Package: libhwy-dev
Architecture: any
Section: libdevel
Pre-Depends: ${misc:Pre-Depends}
Depends: libhwy1 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: Efficient and performance-portable SIMD wrapper (developer files)
 This library provides type-safe and source-code portable wrappers over
 existing platform-specific intrinsics. Its design aims for simplicity,
 reliable efficiency across platforms, and immediate usability with current
 compilers.
 .
 This package installs the development files.

Package: highway-doc
Architecture: all
Section: doc
Depends: doc-base, ${misc:Depends}
Description: Efficient and performance-portable SIMD wrapper (documentation files)
 This library provides type-safe and source-code portable wrappers over
 existing platform-specific intrinsics. Its design aims for simplicity,
 reliable efficiency across platforms, and immediate usability with current
 compilers.
 .
 This package installs the documentation files.

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,7 @@
 	dh $@ --buildsystem=cmake+ninja
 
 # Prefer SCALAR over EMU128 for now, see #1015256
-DEB_CXXFLAGS_MAINT_APPEND += -DHWY_BROKEN_EMU128=1
+#DEB_CXXFLAGS_MAINT_APPEND += -DHWY_BROKEN_EMU128=1
 
 ifneq (,$(filter $(DEB_BUILD_ARCH), armhf armel))
   # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=77728
@@ -18,8 +18,9 @@
 endif
 
 ifeq ($(DEB_BUILD_ARCH),$(filter $(DEB_BUILD_ARCH),armhf))
-  # https://github.com/google/highway/issues/495
-  CMAKE_EXTRA_FLAGS += -DHWY_CMAKE_ARM7:BOOL=OFF
+  # highway implement dynamic dipatch:
+  # https://github.com/google/highway/issues/891
+  CMAKE_EXTRA_FLAGS += -DHWY_CMAKE_ARM7:BOOL=ON
 endif
 
 export DEB_CXXFLAGS_MAINT_APPEND

## highway 1.0.2

=== debian/changelog ===
highway (1.0.2-4aatgv2) unstable; urgency=medium

  * debian/rules:
    - -DBUILD_SHARED_LIBS:BOOL=OFF
  * debian/control:
    - comment libhwy1 package
    - do not depend libhwy-dev on libhwy1
  * debian/libhwy-dev.install:
    - add usr/lib/*/*.a
    - comment usr/lib/*/*.so

 -- Amon Ott <ao@m-privacy.de>  Thu, 26 Jan 2023 09:49:00 +0100

highway (1.0.2-4aaump1) unstable; urgency=medium

  * Build for m-privacy
  * Add RSBAC settings
  * debian/rules:
    - export DEB_CFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects
    - export DEB_CXXFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects
    - export DEB_LDFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects

 -- Amon Ott <ao@m-privacy.de>  Mon, 23 Jan 2023 07:43:55 +0100

highway (1.0.2-4) unstable; urgency=medium

  * d/patches: Add missing atomic library to test

 -- Mathieu Malaterre <malat@debian.org>  Thu, 03 Nov 2022 11:29:42 +0100

highway (1.0.2-3) unstable; urgency=medium

  * d/patches: Fix cmake issue with usage of PRIVATE keyword

 -- Mathieu Malaterre <malat@debian.org>  Thu, 03 Nov 2022 10:34:54 +0100

highway (1.0.2-2) unstable; urgency=medium

  * d/patches: Fix build with atomic lib

 -- Mathieu Malaterre <malat@debian.org>  Thu, 03 Nov 2022 09:38:31 +0100

highway (1.0.2-1) unstable; urgency=medium

  * New upstream version 1.0.2
  * d/patches: Remove patches applied upstream
  * d/symbols: Add new symbols

 -- Mathieu Malaterre <malat@debian.org>  Wed, 02 Nov 2022 15:55:21 +0100

highway (1.0.1-3) unstable; urgency=medium

  * d/patches: Remove some warnings on clang/riscv-64
  * d/patches: Hack around current rdcycle mess
  * d/patches: Remove warnings on arm/gcc-12
  * d/patches: Rename patch to refer upstream
  * d/rules: Make sure to compile without warnings

 -- Mathieu Malaterre <malat@debian.org>  Fri, 02 Sep 2022 12:16:04 +0200

=== debian/control ===
--- 
+++ 
@@ -11,24 +11,12 @@
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/highway
 Rules-Requires-Root: no
 
-Package: libhwy1
-Architecture: any
-Pre-Depends: ${misc:Pre-Depends}
-Depends: ${misc:Depends}, ${shlibs:Depends}
-Multi-Arch: same
-Description: Efficient and performance-portable SIMD wrapper (runtime files)
- This library provides type-safe and source-code portable wrappers over
- existing platform-specific intrinsics. Its design aims for simplicity,
- reliable efficiency across platforms, and immediate usability with current
- compilers.
- .
- This package installs the runtime files.
 
 Package: libhwy-dev
 Architecture: any
 Section: libdevel
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libhwy1 (= ${binary:Version}), ${misc:Depends}
+Depends: ${misc:Depends}
 Multi-Arch: same
 Description: Efficient and performance-portable SIMD wrapper (developer files)
  This library provides type-safe and source-code portable wrappers over

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,10 @@
 #!/usr/bin/make -f
 #export DH_VERBOSE=1
+
+# m-privacy
+export DEB_CFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects
+export DEB_CXXFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects
+export DEB_LDFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects
 
 include /usr/share/dpkg/default.mk
 
@@ -28,8 +33,8 @@
 # test suite rely on CMAKE_SKIP_RPATH=OFF
 CMAKE_EXTRA_FLAGS += \
  -DCMAKE_SKIP_RPATH:BOOL=OFF \
- -DBUILD_SHARED_LIBS:BOOL=ON \
- -DHWY_WARNINGS_ARE_ERRORS:BOOL=OFF \
+ -DBUILD_SHARED_LIBS:BOOL=OFF \
+ -DHWY_WARNINGS_ARE_ERRORS:BOOL=ON \
  -DHWY_SYSTEM_GTEST:BOOL=ON
 
 override_dh_auto_configure-arch:
@@ -71,3 +76,7 @@
 override_dh_compress-indep:
 	# do not compress .pdf/.md files for documentation
 	dh_compress -X.md -X.pdf
+
+override_dh_compress-arch:
+	mp_rsbac
+	dh_compress -a

## highway 1.0.3~git20221102.4899d11

=== debian/changelog ===
highway (1.0.3~git20221102.4899d11-2) experimental; urgency=medium

  * d/patches: Fix atomic support

 -- Mathieu Malaterre <malat@debian.org>  Thu, 03 Nov 2022 12:50:53 +0100

highway (1.0.3~git20221102.4899d11-1) experimental; urgency=medium

  * New upstream version 1.0.3~git20221102.4899d11
  * d/patches: Refresh patches for latest release

 -- Mathieu Malaterre <malat@debian.org>  Thu, 03 Nov 2022 10:21:15 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,11 @@
 Priority: optional
 Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
 Uploaders: Mathieu Malaterre <malat@debian.org>
-Build-Depends: cmake (>= 3.13), debhelper (>= 11), libgtest-dev, ninja-build
+Build-Depends: clang (>= 1:14.0) [riscv64],
+               cmake (>= 3.13),
+               debhelper (>= 11),
+               libgtest-dev,
+               ninja-build
 Build-Depends-Indep: ghostscript
 Standards-Version: 4.6.1
 Homepage: https://github.com/google/highway
@@ -11,12 +15,24 @@
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/highway
 Rules-Requires-Root: no
 
+Package: libhwy1
+Architecture: any
+Pre-Depends: ${misc:Pre-Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Multi-Arch: same
+Description: Efficient and performance-portable SIMD wrapper (runtime files)
+ This library provides type-safe and source-code portable wrappers over
+ existing platform-specific intrinsics. Its design aims for simplicity,
+ reliable efficiency across platforms, and immediate usability with current
+ compilers.
+ .
+ This package installs the runtime files.
 
 Package: libhwy-dev
 Architecture: any
 Section: libdevel
 Pre-Depends: ${misc:Pre-Depends}
-Depends: ${misc:Depends}
+Depends: libhwy1 (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: Efficient and performance-portable SIMD wrapper (developer files)
  This library provides type-safe and source-code portable wrappers over

=== debian/rules ===
--- 
+++ 
@@ -1,10 +1,5 @@
 #!/usr/bin/make -f
 #export DH_VERBOSE=1
-
-# m-privacy
-export DEB_CFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects
-export DEB_CXXFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects
-export DEB_LDFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects
 
 include /usr/share/dpkg/default.mk
 
@@ -14,8 +9,8 @@
 %:
 	dh $@ --buildsystem=cmake+ninja
 
-# Prefer SCALAR over EMU128 for now, see #1015256
-#DEB_CXXFLAGS_MAINT_APPEND += -DHWY_BROKEN_EMU128=1
+# Let's pretend to know what we are doing:
+DEB_CXXFLAGS_MAINT_APPEND += -DHWY_BROKEN_EMU128=0
 
 ifneq (,$(filter $(DEB_BUILD_ARCH), armhf armel))
   # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=77728
@@ -28,12 +23,20 @@
   CMAKE_EXTRA_FLAGS += -DHWY_CMAKE_ARM7:BOOL=ON
 endif
 
+# HWY_RVV requires `-march=rv64gcv1p0 -menable-experimental-extensions`
+ifeq ($(DEB_BUILD_ARCH),$(filter $(DEB_BUILD_ARCH),riscv64))
+  CC=clang
+  CXX=clang++
+endif
+
+export CC
+export CXX
 export DEB_CXXFLAGS_MAINT_APPEND
 
 # test suite rely on CMAKE_SKIP_RPATH=OFF
 CMAKE_EXTRA_FLAGS += \
  -DCMAKE_SKIP_RPATH:BOOL=OFF \
- -DBUILD_SHARED_LIBS:BOOL=OFF \
+ -DBUILD_SHARED_LIBS:BOOL=ON \
  -DHWY_WARNINGS_ARE_ERRORS:BOOL=ON \
  -DHWY_SYSTEM_GTEST:BOOL=ON
 
@@ -76,7 +79,3 @@
 override_dh_compress-indep:
 	# do not compress .pdf/.md files for documentation
 	dh_compress -X.md -X.pdf
-
-override_dh_compress-arch:
-	mp_rsbac
-	dh_compress -a

=== debian/watch ===
version=4
opts="mode=git,pgpmode=none,pretty=1.0.3~git%cd.%h" \
https://github.com/google/highway \
HEAD debian uupdate

## highway 1.0.3

=== debian/changelog ===
highway (1.0.3-3) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: (Closes: #1024244)
  * Fix a pile of build vs host confusions.

 -- Mathieu Malaterre <malat@debian.org>  Fri, 24 Feb 2023 08:52:20 +0100

highway (1.0.3-2) unstable; urgency=medium

  * d/control: Bump Std-Vers to 4.6.2 no changes needed
  * d/patches: Make sure to put hwy target in hwy:: namespace

 -- Mathieu Malaterre <malat@debian.org>  Wed, 01 Feb 2023 18:57:25 +0100

highway (1.0.3-1) unstable; urgency=medium

  * New upstream version 1.0.3
  * d/patches: Remove patches applied upstream
  * d/patches: Generate and install a HWYConfig.cmake file
  * d/patches: Fixed HWY_SCALAR BitCast to copy only sizeof(T) bytes
  * d/install: Install *.cmake files

 -- Mathieu Malaterre <malat@debian.org>  Sun, 29 Jan 2023 15:52:03 +0100

=== debian/rules ===
--- 
+++ 
@@ -9,28 +9,22 @@
 %:
 	dh $@ --buildsystem=cmake+ninja
 
-# Let's pretend to know what we are doing:
-DEB_CXXFLAGS_MAINT_APPEND += -DHWY_BROKEN_EMU128=0
+# Prefer SCALAR over EMU128 for now, see #1015256
+#DEB_CXXFLAGS_MAINT_APPEND += -DHWY_BROKEN_EMU128=1
 
-ifneq (,$(filter $(DEB_BUILD_ARCH), armhf armel))
+ifneq (,$(filter $(DEB_HOST_ARCH), armel armhf))
   # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=77728
   DEB_CXXFLAGS_MAINT_APPEND += -Wno-psabi
 endif
 
-ifeq ($(DEB_BUILD_ARCH),$(filter $(DEB_BUILD_ARCH),armhf))
+ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),armhf))
   # highway implement dynamic dipatch:
   # https://github.com/google/highway/issues/891
   CMAKE_EXTRA_FLAGS += -DHWY_CMAKE_ARM7:BOOL=ON
 endif
 
-# HWY_RVV requires `-march=rv64gcv1p0 -menable-experimental-extensions`
-ifeq ($(DEB_BUILD_ARCH),$(filter $(DEB_BUILD_ARCH),riscv64))
-  CC=clang
-  CXX=clang++
-endif
+include /usr/share/dpkg/buildtools.mk
 
-export CC
-export CXX
 export DEB_CXXFLAGS_MAINT_APPEND
 
 # test suite rely on CMAKE_SKIP_RPATH=OFF
@@ -40,9 +34,14 @@
  -DHWY_WARNINGS_ARE_ERRORS:BOOL=ON \
  -DHWY_SYSTEM_GTEST:BOOL=ON
 
+ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+CMAKE_EXTRA_FLAGS += -DBUILD_TESTING=OFF
+endif
+
 override_dh_auto_configure-arch:
 	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)
 
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 # run default example to check compilation ok:
 override_dh_install-arch:
 ifeq (,$(filter $(DEB_BUILD_ARCH),hurd-i386))
@@ -51,6 +50,7 @@
 	echo "CPU 'QEMU Virtual CPU version 2.5+' does not support RDTSCP, skipping benchmark."
 endif
 	dh_install
+endif
 
 override_dh_clean-indep:
 	dh_clean debian_docs/

## highway 1.0.4~git20230223.a24a3f7

=== debian/changelog ===
highway (1.0.4~git20230223.a24a3f7-1) experimental; urgency=medium

  [ Mathieu Malaterre ]
  * New upstream version 1.0.4~git20230223.a24a3f7

 -- Mathieu Malaterre <malat@debian.org>  Fri, 24 Feb 2023 09:03:15 +0100

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
                libgtest-dev,
                ninja-build
 Build-Depends-Indep: ghostscript
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/google/highway
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/highway.git
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/highway

=== debian/rules ===
--- 
+++ 
@@ -9,8 +9,8 @@
 %:
 	dh $@ --buildsystem=cmake+ninja
 
-# Prefer SCALAR over EMU128 for now, see #1015256
-#DEB_CXXFLAGS_MAINT_APPEND += -DHWY_BROKEN_EMU128=1
+# Let's pretend to know what we are doing:
+DEB_CXXFLAGS_MAINT_APPEND += -DHWY_BROKEN_EMU128=0
 
 ifneq (,$(filter $(DEB_HOST_ARCH), armel armhf))
   # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=77728
@@ -25,6 +25,14 @@
 
 include /usr/share/dpkg/buildtools.mk
 
+# HWY_RVV requires `-march=rv64gcv1p0 -menable-experimental-extensions`
+ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),riscv64))
+  CC=clang
+  CXX=clang++
+endif
+
+export CC
+export CXX
 export DEB_CXXFLAGS_MAINT_APPEND
 
 # test suite rely on CMAKE_SKIP_RPATH=OFF

=== debian/watch ===
version=4
opts="mode=git,pgpmode=none,pretty=1.0.4~git%cd.%h" \
https://github.com/google/highway \
HEAD debian uupdate

## highway 1.0.5~git20230612.46fb57d

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,13 +19,25 @@
   cmake_policy(SET CMP0083 NEW)
 endif()
 
-project(hwy VERSION 1.0.0)  # Keep in sync with highway.h version
+# Workaround for 3.19 raising error 'IMPORTED_LOCATION not set for imported
+# target "GTest::gtest_main"'.
+if(POLICY CMP0111)
+  cmake_policy(SET CMP0111 OLD)
+endif()
+
+project(hwy VERSION 1.0.4)  # Keep in sync with highway.h version
+# `hwy` is lowercase to handle find_package() in Config mode:
+set(namespace "${PROJECT_NAME}::")
 
 # Directly define the ABI version from the cmake project() version values:
 set(LIBRARY_VERSION "${hwy_VERSION}")
 set(LIBRARY_SOVERSION ${hwy_VERSION_MAJOR})
 
 set(CMAKE_CXX_EXTENSIONS OFF)
+
+list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
+# Search for Atomics implementation:
+find_package(Atomics REQUIRED)
 
 # Enabled PIE binaries by default if supported.
 include(CheckPIESupported OPTIONAL RESULT_VARIABLE CHECK_PIE_SUPPORTED)
@@ -42,7 +54,8 @@
   set(CMAKE_BUILD_TYPE RelWithDebInfo)
 endif()
 
-set(HWY_CMAKE_ARM7 OFF CACHE BOOL "Set copts for ARMv7 with NEON (requires vfpv4)?")
+# The following is only required with GCC < 6.1.0 or CLANG < 16.0
+set(HWY_CMAKE_ARM7 OFF CACHE BOOL "Set copts for Armv7 with NEON (requires vfpv4)?")
 
 # Unconditionally adding -Werror risks breaking the build when new warnings
 # arise due to compiler/platform changes. Enable this in CI/tests.
@@ -51,6 +64,7 @@
 set(HWY_ENABLE_CONTRIB ON CACHE BOOL "Include contrib/")
 set(HWY_ENABLE_EXAMPLES ON CACHE BOOL "Build examples")
 set(HWY_ENABLE_INSTALL ON CACHE BOOL "Install library")
+set(HWY_ENABLE_TESTS ON CACHE BOOL "Enable HWY tests")
 
 include(CheckCXXSourceCompiles)
 check_cxx_source_compiles(
@@ -89,6 +103,9 @@
     hwy/contrib/sort/vqsort-inl.h
     hwy/contrib/sort/vqsort.cc
     hwy/contrib/sort/vqsort.h
+    hwy/contrib/algo/copy-inl.h
+    hwy/contrib/algo/find-inl.h
+    hwy/contrib/algo/transform-inl.h
 )
 endif()  # HWY_ENABLE_CONTRIB
 
@@ -108,10 +125,13 @@
     hwy/ops/arm_sve-inl.h
     hwy/ops/emu128-inl.h
     hwy/ops/generic_ops-inl.h
+    hwy/ops/ppc_vsx-inl.h
+    hwy/ops/rvv-inl.h
     hwy/ops/scalar-inl.h
     hwy/ops/set_macros-inl.h
     hwy/ops/shared-inl.h
     hwy/ops/wasm_128-inl.h
+    hwy/ops/tuple-inl.h
     hwy/ops/x86_128-inl.h
     hwy/ops/x86_256-inl.h
     hwy/ops/x86_512-inl.h
@@ -120,8 +140,12 @@
     hwy/print-inl.h
     hwy/print.cc
     hwy/print.h
+    hwy/robust_statistics.h
     hwy/targets.cc
     hwy/targets.h
+    hwy/timer.cc
+    hwy/timer.h
+    hwy/timer-inl.h
 )
 
 set(HWY_TEST_SOURCES
@@ -222,6 +246,9 @@
   endif()  # HWY_CMAKE_ARM7
 
   if(HWY_RISCV)
+    # gcc(13) and recent clang both support V, but not yet runtime dispatch, so
+    # we add the gcv compiler flag, which then requires the CPU (now when using
+    # either compiler) to support V.
     list(APPEND HWY_FLAGS -march=rv64gcv1p0)
     if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
       list(APPEND HWY_FLAGS -menable-experimental-extensions)
@@ -239,6 +266,13 @@
   endif()
 
 endif()  # !MSVC
+
+include(CheckIncludeFile)
+check_include_file(sys/auxv.h  HAVE_SYS_AUXV_H)
+check_include_file(asm/hwcap.h HAVE_ASM_HWCAP_H)
+if (NOT HAVE_ASM_HWCAP_H)
+  list(APPEND HWY_FLAGS -DTOOLCHAIN_MISS_ASM_HWCAP_H)
+endif()
 
 # By default prefer STATIC build (legacy behavior)
 option(BUILD_SHARED_LIBS "Build shared libraries" OFF)
@@ -264,6 +298,9 @@
 endif()
 
 add_library(hwy ${HWY_LIBRARY_TYPE} ${HWY_SOURCES})
+if(NOT HAVE_SYS_AUXV_H)
+  target_compile_definitions(hwy PUBLIC TOOLCHAIN_MISS_SYS_AUXV_H)
+endif()
 target_compile_definitions(hwy PUBLIC "${DLLEXPORT_TO_DEFINE}")
 target_compile_options(hwy PRIVATE ${HWY_FLAGS})
 set_property(TARGET hwy PROPERTY POSITION_INDEPENDENT_CODE ON)
@@ -274,6 +311,8 @@
 target_compile_features(hwy PUBLIC cxx_std_11)
 set_target_properties(hwy PROPERTIES
   LINK_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/hwy/hwy.version)
+# For GCC __atomic_store_8, see #887
+target_link_libraries(hwy PRIVATE ${ATOMICS_LIBRARIES})
 # not supported by MSVC/Clang, safe to skip (we use DLLEXPORT annotations)
 if(UNIX AND NOT APPLE)
   set_property(TARGET hwy APPEND_STRING PROPERTY
@@ -328,38 +367,3 @@
 # Naked target also not always could be run (due to the lack of '.\' prefix)
 # Thus effective command to run should contain the full path
 # and emulator prefix (if any).
-if (NOT CMAKE_CROSSCOMPILING OR CMAKE_CROSSCOMPILING_EMULATOR)
-add_custom_command(TARGET hwy_list_targets POST_BUILD
-    COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:hwy_list_targets> || (exit 0))
-endif()
-
-# --------------------------------------------------------
-# Allow skipping the following sections for projects that do not need them:
-# tests, examples, benchmarks and installation.
-
-# -------------------------------------------------------- install library
-if (HWY_ENABLE_INSTALL)
-
-install(TARGETS hwy
-  LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
-  ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
-  RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")
-# Install all the headers keeping the relative path to the current directory
-# when installing them.
-foreach (source ${HWY_SOURCES})
-  if ("${source}" MATCHES "\.h$")
-    get_filename_component(dirname "${source}" DIRECTORY)
-    install(FILES "${source}"
-        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${dirname}")
-  endif()
-endforeach()
-
-if (HWY_ENABLE_CONTRIB)
-install(TARGETS hwy_contrib
-  LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
-  ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
-  RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")
-# Install all the headers keeping the relative path to the current directory
-# when installing them.
-foreach (source ${HWY_CONTRIB_SOURCES})
-  if ("${source}" MATCHES "\.h$")

=== debian/changelog ===
highway (1.0.5~git20230612.46fb57d-1) experimental; urgency=medium

  * d/watch: Point to latest git
  * New upstream version 1.0.5~git20230612.46fb57d
  * d/patches: Refresh patches
  * d/control: Try gcc-13 release
  * d/patches: Fix compilation on i386
  * d/symbols: Update symbols to match latest ABI

 -- Mathieu Malaterre <malat@debian.org>  Tue, 13 Jun 2023 15:38:57 +0200

highway (1.0.4~git20230317.8681eb8-1) experimental; urgency=medium

  * d/patches: Re-enable RVV on GCC-13
  * New upstream version 1.0.4~git20230317.8681eb8
  * d/patches: Refresh patches for new upstream

 -- Mathieu Malaterre <malat@debian.org>  Fri, 17 Mar 2023 14:07:06 +0100

highway (1.0.4~git20230308.a1d7764-1) experimental; urgency=medium

  * d/patches: Remove old patch
  * New upstream version 1.0.4~git20230308.a1d7764
  * d/patches: Refresh patches for new upstream
  * d/rules: Start building ppc8
  * d/patches: Fix compilation on ppc64el
  * d/patches: Allow ppc8 on powerpc arch

 -- Mathieu Malaterre <malat@debian.org>  Wed, 08 Mar 2023 11:32:36 +0100

highway (1.0.4~git20230228.edd5410-1) experimental; urgency=medium

  * New upstream version 1.0.4~git20230228.edd5410
  * d/patches: Refresh patches for new upstream

 -- Mathieu Malaterre <malat@debian.org>  Wed, 01 Mar 2023 08:08:16 +0100

highway (1.0.4~git20230227.dc5c141-2) experimental; urgency=medium

  * d/patches: Remove warnings on ppc64el
  * d/patches: Start building HWY_PPC8 on ppc64

 -- Mathieu Malaterre <malat@debian.org>  Mon, 27 Feb 2023 15:33:35 +0100

highway (1.0.4~git20230227.dc5c141-1) experimental; urgency=medium

  * d/rules: Start using gcc-snapshot
  * d/patches: Fix compilation issue on riscv64
  * New upstream version 1.0.4~git20230227.dc5c141

 -- Mathieu Malaterre <malat@debian.org>  Mon, 27 Feb 2023 13:46:44 +0100

=== debian/rules ===
--- 
+++ 
@@ -23,17 +23,17 @@
   CMAKE_EXTRA_FLAGS += -DHWY_CMAKE_ARM7:BOOL=ON
 endif
 
+ifneq (,$(filter $(DEB_HOST_ARCH), powerpc ppc64))
+  DEB_CXXFLAGS_MAINT_APPEND += -maltivec -mcpu=power8
+endif
+
 include /usr/share/dpkg/buildtools.mk
 
-# HWY_RVV requires `-march=rv64gcv1p0 -menable-experimental-extensions`
-ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),riscv64))
-  CC=clang
-  CXX=clang++
-endif
+CC=gcc-13
+CXX=g++-13
 
 export CC
 export CXX
-export DEB_CXXFLAGS_MAINT_APPEND
 
 # test suite rely on CMAKE_SKIP_RPATH=OFF
 CMAKE_EXTRA_FLAGS += \

## highway 1.0.5~git20230620.ed184dc

=== debian/changelog ===
highway (1.0.5~git20230620.ed184dc-1) experimental; urgency=medium

  * New upstream version 1.0.5~git20230620.ed184dc
  * d/patches: Refresh patches for new snapshot

 -- Mathieu Malaterre <malat@debian.org>  Tue, 20 Jun 2023 12:30:49 +0200

highway (1.0.5~git20230612.46fb57d-3) experimental; urgency=medium

  * d/patches: Fix measurement issue on powerpc32
  * d/patches: Add missing -latomic linking
  * d/patches: Fix compilation on armhf
  * d/patches: Fix compilation on amd64

 -- Mathieu Malaterre <malat@debian.org>  Fri, 16 Jun 2023 11:55:14 +0200

highway (1.0.5~git20230612.46fb57d-2) experimental; urgency=medium

  * d/rules: Re-activate ppc+altivec compilation
  * d/patches: Try to fix ABI change in contrib

 -- Mathieu Malaterre <malat@debian.org>  Wed, 14 Jun 2023 17:14:02 +0200

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Priority: optional
 Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
 Uploaders: Mathieu Malaterre <malat@debian.org>
-Build-Depends: clang (>= 1:14.0) [riscv64],
-               cmake (>= 3.13),
+Build-Depends: cmake (>= 3.13),
                debhelper (>= 11),
+               g++-13,
                libgtest-dev,
                ninja-build
 Build-Depends-Indep: ghostscript

=== debian/rules ===
--- 
+++ 
@@ -34,6 +34,7 @@
 
 export CC
 export CXX
+export DEB_CXXFLAGS_MAINT_APPEND
 
 # test suite rely on CMAKE_SKIP_RPATH=OFF
 CMAKE_EXTRA_FLAGS += \

=== debian/watch ===
version=4
opts="mode=git,pgpmode=none,pretty=1.0.5~git%cd.%h" \
https://github.com/google/highway \
HEAD debian uupdate
